/*
 * XBee Star : the Coordinator
 * ----------------------------
 * XBee #1 is the coordinator (one sender)
 * XBee #2, #3, ... are end devices (multiple receivers)
 * Coordinator : ATRE, ATID1111, ATBD6, ATCE1, ATAP2, ATWR
 * End #2      : ATRE, ATID1111, ATBD6, ATMY2, ATAP2, ATWR
 * End #3      : ATRE, ATID1111, ATBD6, ATMY3, ATAP2, ATWR
 * ...
 *
 * Author: jeromeabel.net
 * Licence: GNU/GPL3
 * Date: 2014-09
 * Art project: http://jeromeabel.net/art/patatas-de-goma
 */

#include <XBee.h>
#include <SerialCommand.h>

SerialCommand sCmd;
XBee xbee = XBee();

// ---- DATA --- //
// Size 7 bytes (max = 100 bytes)
// data[0] = klaxon 1 tone
// data[1] = klaxon 1 pwm
// data[2] = klaxon 2 tone
// data[3] = klaxon 2 pwm
// data[4] = phare 1 
// data[5] = phare 2
// data[6] = periodePWM
uint8_t data2[] = { 0, 0, 0, 0, 0, 0, 0};
uint8_t data3[] = { 0, 0, 0, 0, 0, 0, 0};
uint8_t data4[] = { 0, 0, 0, 0, 0, 0, 0};
uint8_t data5[] = { 0, 0, 0, 0, 0, 0, 0};

// XBee packet to transmit
Tx16Request tx2 = Tx16Request(0x2, data2, sizeof(data2));  //addr = 0x2
Tx16Request tx3 = Tx16Request(0x3, data3, sizeof(data3));  //addr = 0x3
Tx16Request tx4 = Tx16Request(0x4, data4, sizeof(data4));  //addr = 0x4
Tx16Request tx5 = Tx16Request(0x5, data5, sizeof(data5));  //addr = 0x5

void setup() {
  Serial1.begin(57600); 
  xbee.setSerial(Serial1);
  sCmd.addCommand("xbee2", xbee2);
  sCmd.addCommand("xbee3", xbee3);
  sCmd.addCommand("xbee4", xbee4);
  sCmd.addCommand("xbee5", xbee5);
}

void loop() {
   sCmd.readSerial();
}

// ---- SEND XBEE PACKETS ---- //
void xbee2() {
  char *arg;
  arg = sCmd.next();
  if (arg != NULL) data2[0] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data2[1] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data2[2] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data2[3] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data2[4] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data2[5] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data2[6] = atoi(arg);
  xbee.send(tx2);
}

void xbee3() {
  char *arg;
  arg = sCmd.next();
  if (arg != NULL) data3[0] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data3[1] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data3[2] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data3[3] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data3[4] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data3[5] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data3[6] = atoi(arg);
  xbee.send(tx3);
}

void xbee4() {
  char *arg;
  arg = sCmd.next();
  if (arg != NULL) data4[0] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data4[1] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data4[2] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data4[3] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data4[4] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data4[5] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data4[6] = atoi(arg);
  xbee.send(tx4);
}

void xbee5() {
  char *arg;
  arg = sCmd.next();
  if (arg != NULL) data5[0] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data5[1] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data5[2] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data5[3] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data5[4] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data5[5] = atoi(arg);
  arg = sCmd.next();
  if (arg != NULL) data5[6] = atoi(arg);
  xbee.send(tx5);
}
